﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Threading;

namespace CSMonitor
{
    class Program
    {
        static bool flag;
        static SerialPort _serialPort;

        static void Main(string[] args)
        {
            String message;
            StringComparer stringComparer = StringComparer.OrdinalIgnoreCase;
            Thread readThread = new Thread(Read);

            // Create a new SerialPort object with default settings.
            _serialPort = new SerialPort();

            // Allow the user to set the appropriate properties.
            _serialPort.PortName = "COM9";
            _serialPort.BaudRate = 9600;
            _serialPort.Parity = (Parity)Enum.Parse(typeof(Parity), "None");
            _serialPort.DataBits = 8;
            _serialPort.StopBits = (StopBits)Enum.Parse(typeof(StopBits), "One");
            _serialPort.Handshake = (Handshake)Enum.Parse(typeof(Handshake), "None");

            // Set the read/write timeouts
            _serialPort.ReadTimeout = 500;
            _serialPort.WriteTimeout = 500;

            _serialPort.Open();
            flag = true;
            readThread.Start();

            Console.WriteLine("Type \"quit\" to exit");
            while (flag)
            {
                message = Console.ReadLine();
                if (stringComparer.Equals("quit", message))
                {
                    flag = false;
                }
                else
                {
                    _serialPort.WriteLine(message);
                }
            }
            readThread.Join();
            _serialPort.Close();
        }

        public static void Read()
        {
            while (flag)
            {
                try
                {
                    string message = _serialPort.ReadLine();
                    Console.WriteLine("double: {0}", Convert.ToDouble((String)message) / 2.0);
                }
                catch (TimeoutException) { }
            }
        }
    }
}
