﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Windows.Forms.DataVisualization.Charting;

namespace CSSerialF
{
    public partial class Form1 : Form
    {
        static SerialPort _serialPort;
        double[] data = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
        public Form1()
        {
            InitializeComponent();
            _serialPort = new SerialPort();
            // Allow the user to set the appropriate properties.
            _serialPort.PortName = "COM3";
            _serialPort.BaudRate = 9600;
            _serialPort.Parity = (Parity)Enum.Parse(typeof(Parity), "None");
            _serialPort.DataBits = 8;
            _serialPort.StopBits = (StopBits)Enum.Parse(typeof(StopBits), "One");
            _serialPort.Handshake = (Handshake)Enum.Parse(typeof(Handshake), "None");

            // Set the read/write timeouts
            _serialPort.ReadTimeout = 500;
            _serialPort.WriteTimeout = 500;

            _serialPort.Open();
        }
        private void plot()
        {
            Series series1 = new Series("温度");
            _serialPort.WriteLine("T");
            for (int i = 0; i < 10; i++)
            {
                string message = _serialPort.ReadLine();
                data[i] = Convert.ToDouble((String)message);
            }
            for (int x = 1; x < 10; x++)
            {
                series1.Points.AddXY(x, data[x]);
            }
            {
                series1.Color = Color.Violet;
                series1.MarkerSize = 15;
                series1.MarkerStyle = System.Windows.Forms.DataVisualization.Charting.MarkerStyle.Diamond;
                series1.IsValueShownAsLabel = true;
                series1.LabelForeColor = Color.Blue;
                series1.ChartType = SeriesChartType.Line; // グラフ形状 
            }
            {
                chart1.Series.Clear();
                chart1.Series.Add(series1);
                chart1.ChartAreas[0].BackColor = Color.LightCyan;
            }
            {
                Axis ax = chart1.ChartAreas[0].AxisX;
                ax.MajorGrid.LineColor = Color.LightGray;
                Axis ay = chart1.ChartAreas[0].AxisY;
                ay.MajorGrid.LineColor = Color.LightGray;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            _serialPort.WriteLine("H");
            textBox1.Text = _serialPort.ReadLine();

        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            _serialPort.WriteLine("L");
            textBox1.Text = _serialPort.ReadLine();
        }

        private void button4_Click_1(object sender, EventArgs e)
        {
            plot();
            textBox1.Text = "G OK\n";
        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            textBox1.Text = "Close";
            _serialPort.Close();
            Close();

        }
    }
}
